﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace testSummaryInHeader
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        bool notSummary = true;
        public Window1()
        {
            InitializeComponent();
            xamDataGrid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(xamDataGrid1_FieldLayoutInitialized);
            xamDataGrid1.SummaryResultChanged += new EventHandler<Infragistics.Windows.DataPresenter.Events.SummaryResultChangedEventArgs>(xamDataGrid1_SummaryResultChanged);
            xamDataGrid1.RecordExpanded += new EventHandler<Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs>(xamDataGrid1_RecordExpanded);

            Head h = new Head();
            h.Name = "Head";

            CustomData cd = new CustomData();
            cd.Name = "Item 1";
            cd.Cost = 500;
            cd.SubItems = new List<CustomData>();
            cd.SubItems.Add(new CustomData() { Name = "Sub Item 1", Cost = 200 });
            cd.SubItems.Add(new CustomData() { Name = "Sub Item 2", Cost = 300 });


            CustomData cd1 = new CustomData();
            cd1.Name = "Item 2";
            cd1.Cost = 600;
            cd1.SubItems = new List<CustomData>();
            cd1.SubItems.Add(new CustomData() { Name = "Sub Item 1", Cost = 350 });
            cd1.SubItems.Add(new CustomData() { Name = "Sub Item 2", Cost = 250 });

            h.HeadData = new List<CustomData>();

            h.HeadData.Add(cd);
            h.HeadData.Add(cd1);

            xamDataGrid1.DataItems.Add(h);


        }

        void xamDataGrid1_RecordExpanded(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs e)
        {
            if (e.Record.ParentRecord.FieldLayout.IsDefault)
            {
                notSummary = false;
            }
            else
                notSummary = true;
        }

        void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            if (e.FieldLayout.IsDefault)
            {
                UnboundField f = new UnboundField();
                f.Settings.LabelPresenterStyle = xamDataGrid1.Resources["style"] as Style;
                e.FieldLayout.Fields.Add(f);
                f.Name = "Total";
            }
            else
            {
                e.FieldLayout.SummaryDefinitions.Add(new SummaryDefinition() { Calculator = SummaryCalculator.Sum, SourceFieldName = "Cost" });
            }
        }

        void xamDataGrid1_SummaryResultChanged(object sender, Infragistics.Windows.DataPresenter.Events.SummaryResultChangedEventArgs e)
        {
            if (notSummary)
            {
                xamDataGrid1.Tag = e.SummaryResult.DisplayText;
            }

        }
    }
    public class CustomData
    {
        public string Name { get; set; }
        public double Cost { get; set; }
        public List<CustomData> SubItems { get; set; }
    }
    public class Head
    {
        public string Name { get; set; }
        public List<CustomData> HeadData { get; set; }
    }
}
